
import java.awt.*;

public class GraphCanvas extends Canvas{

    final int HEIGHT;
    final int WIDTH;
    int x_max;
    int y_max;
    int measurements = 10000;
    int point_index = 0;
    double x_scale;
    double y_scale;
    double y_scale_2;
    double[] xpoints;
    double[] ypoints;
    double[] xpoints2;
    double[] ypoints2;
    Image offImage;
    Graphics g;

    GraphCanvas(int w, int h){

	  WIDTH = w;
	  HEIGHT = h;
	  xpoints = new double[measurements];
	  ypoints = new double[measurements];
	  xpoints2 = new double[measurements];
	  ypoints2 = new double[measurements];
	  x_max = WIDTH;
	  y_max = HEIGHT;
	  setMax(1000, 1000);
	  setBackground(Color.black);

    }//constructor

    public void paint(Graphics g){

        update(g);

    }//paint

    public void update(Graphics h){
//        if (g == null){
            offImage = createImage(getSize().width, getSize().height);
            g = offImage.getGraphics();
//        }//if

	  g.setColor(Color.white);

	  for(int i=0; i<WIDTH; i+=80)
		g.drawLine(i, 0, i, HEIGHT);
	  for(int i=0; i<HEIGHT; i+=20)
		g.drawLine(0, i, WIDTH, i);

	  g.setColor(Color.white);

	  g.drawRect(0, 0, WIDTH-1, HEIGHT-1);

	  g.setColor(new Color(255, 150, 150));
	  for(int i=1; i<point_index; i++){
		g.drawLine((int)(xpoints[i]*x_scale), 
			     (int)(HEIGHT-ypoints[i]*y_scale_2), 
			     (int)(xpoints[i-1]*x_scale), 
			     (int)(HEIGHT-ypoints[i-1]*y_scale_2));
	  }//for
	  g.setColor(new Color(150, 150, 255));
	  for(int i=1; i<point_index; i++){
		g.drawLine((int)(xpoints2[i]*x_scale), 
			     (int)(HEIGHT-ypoints2[i]*y_scale), 
			     (int)(xpoints2[i-1]*x_scale), 
			     (int)(HEIGHT-ypoints2[i-1]*y_scale));
	  }//for

	  g.setColor(Color.white);
	  for(int i=80; i<WIDTH; i+=80){
	      g.drawString((int)(i/((double)WIDTH/x_max))+" Myrs", i-20, HEIGHT-5);
	  }//for

          g.setColor(new Color(150, 150, 255));
          g.drawString("V (km/s)",WIDTH-50,HEIGHT-85);
	  for(int i=20; i<HEIGHT; i+=20){
	      g.drawString(""+(i/((double)HEIGHT/y_max)), WIDTH-40, HEIGHT-i+11);
	  }//for

	  g.setColor(new Color(255, 150, 150));
	  g.drawString("R (kpc)",5,HEIGHT-85);
          for(int i=20; i<HEIGHT; i+=20){
	      g.drawString(""+(i/((double)HEIGHT/150)), 5, HEIGHT-i+11);
	  }//for

        h.drawImage(offImage, 0, 0, this);

    }//update

    public void reset(){

	  xpoints = new double[measurements];
	  ypoints = new double[measurements];
	  xpoints2 = new double[measurements];
	  ypoints2 = new double[measurements];
	  point_index = 0;
	  repaint();

    }//reset

    public void setMax(int x_max, int y_max){

	  this.x_max = x_max;
	  this.y_max = y_max;
	  x_scale = (double)WIDTH/x_max;
	  y_scale = (double)HEIGHT/y_max;
	  y_scale_2 = y_scale*(200/30);
	  reset();
	  repaint();

    }//setScale

    public void addPoints(double x, double y, double x2, double y2){

	  if(point_index<measurements){ 
	      xpoints[point_index] = x;
	      ypoints[point_index] = y;
	      xpoints2[point_index] = x2;
	      ypoints2[point_index] = y2;
	      point_index++;
	      repaint();
	  }//if

    }//addPoint

    public Dimension getPreferredSize(){

	  return new Dimension(WIDTH, HEIGHT);

    }//getPreferredSize

}//GraphCanvas





